scala.tools.nsc.transform.patmat

# MatchTreeMaking

#### trait MatchTreeMaking extends MatchCodeGen with Debugging

Translate our IR (TreeMakers) into actual Scala Trees using the factory methods in MatchCodeGen.

The IR is mostly concerned with sequencing, substitution, and rendering all necessary conditions, mostly agnostic to whether we're in optimized/pure (virtualized) mode.

Source
  MatchTreeMaking.scala

Linear Supertypes
Debugging, MatchCodeGen, Interface, TreeDSL, AnyRef, Any
Known Subclasses
MatchAnalysis, MatchApproximation, MatchOptimization, PatternMatching, patmat
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. MatchTreeMaking
2. Debugging
3. MatchCodeGen
4. Interface
5. TreeDSL
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### trait CodegenCore extends MatchMonadInterface

   Definition Classes
     MatchCodeGen

2. #### trait MatchMonadInterface extends AnyRef

   Interface with user-defined match monad? if there's a `__match` in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:

   Interface with user-defined match monad? if there's a `__match` in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:

       type Matcher[P[_], M[+_], A] = {
         def flatMap[B](f: P[A] => M[B]): M[B]
         def orElse[B >: A](alternative: => M[B]): M[B]
       }

       abstract class MatchStrategy[P[_], M[+_]] {
         // runs the matcher on the given input
         def runOrElse[T, U](in: P[T])(matcher: P[T] => M[U]): P[U]

         def zero: M[Nothing]
         def one[T](x: P[T]): M[T]
         def guard[T](cond: P[Boolean], then: => P[T]): M[T]
       }

   P and M are derived from one's signature (`def one[T](x: P[T]): M[T]`)

   if no `__match` is found, we assume the following implementation (and generate optimized code accordingly)

       object __match extends MatchStrategy[({type Id[x] = x})#Id, Option] {
         def zero = None
         def one[T](x: T) = Some(x)
         // NOTE: guard's return type must be of the shape M[T], where M is the monad in which the pattern match should be interpreted
         def guard[T](cond: Boolean, then: => T): Option[T] = if(cond) Some(then) else None
         def runOrElse[T, U](x: T)(f: T => Option[U]): U = f(x) getOrElse (throw new MatchError(x))
       }

   Definition Classes
     Interface

3. #### trait OptimizedCodegen extends CodegenCore with TypedSubstitution with MatchMonadInterface

   Definition Classes
     MatchCodeGen

4. #### trait PureCodegen extends CodegenCore with PureMatchMonadInterface

   Definition Classes
     MatchCodeGen

5. #### trait PureMatchMonadInterface extends MatchMonadInterface

   Definition Classes
     MatchCodeGen

6. #### final case class Suppression(exhaustive: Boolean, unreachable: Boolean) extends Product with Serializable

7. #### trait TreeMakers extends TypedSubstitution with CodegenCore

8. #### trait TypedSubstitution extends MatchMonadInterface

   Definition Classes
     Interface

### Abstract Value Members

1. #### abstract val global: Global

   Definition Classes
     Debugging

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from MatchTreeMaking to any2stringadd[MatchTreeMaking] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (MatchTreeMaking, B)

   Implicit information
     This member is added by an implicit conversion from MatchTreeMaking to ArrowAssoc[MatchTreeMaking] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### object CODE

   Definition Classes
     TreeDSL

7. #### object Suppression extends Serializable

8. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

9. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

10. #### final def dealiasWiden(tp: Global.Type): Global.Type

    Attributes
      protected
    Definition Classes
      Interface

11. #### object debug

    Definition Classes
      Debugging

12. #### def ensuring(cond: (MatchTreeMaking) ⇒ Boolean, msg: ⇒ Any): MatchTreeMaking

    Implicit information
      This member is added by an implicit conversion from MatchTreeMaking to Ensuring[MatchTreeMaking] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: (MatchTreeMaking) ⇒ Boolean): MatchTreeMaking

    Implicit information
      This member is added by an implicit conversion from MatchTreeMaking to Ensuring[MatchTreeMaking] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean, msg: ⇒ Any): MatchTreeMaking

    Implicit information
      This member is added by an implicit conversion from MatchTreeMaking to Ensuring[MatchTreeMaking] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: Boolean): MatchTreeMaking

    Implicit information
      This member is added by an implicit conversion from MatchTreeMaking to Ensuring[MatchTreeMaking] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

17. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

18. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

19. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from MatchTreeMaking to StringFormat[MatchTreeMaking] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

20. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

21. #### final def hasStableSymbol(p: Global.Tree): Boolean

    Attributes
      protected
    Definition Classes
      Interface

22. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

23. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

24. #### final def mkFALSE: Global.Literal

    Attributes
      protected
    Definition Classes
      Interface

25. #### final def mkTRUE: Global.Literal

    Attributes
      protected
    Definition Classes
      Interface

26. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

27. #### final def notify(): Unit

    Definition Classes
      AnyRef

28. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

29. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

30. #### def toString(): String

    Definition Classes
      AnyRef → Any

31. #### object vpmName

    Definition Classes
      Interface

32. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

33. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

34. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

35. #### def →[B](y: B): (MatchTreeMaking, B)

    Implicit information
      This member is added by an implicit conversion from MatchTreeMaking to ArrowAssoc[MatchTreeMaking] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Debugging

### Inherited from MatchCodeGen

### Inherited from Interface

### Inherited from TreeDSL

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from MatchTreeMaking to any2stringadd[MatchTreeMaking]

### Inherited by implicit conversion StringFormat from MatchTreeMaking to StringFormat[MatchTreeMaking]

### Inherited by implicit conversion Ensuring from MatchTreeMaking to Ensuring[MatchTreeMaking]

### Inherited by implicit conversion ArrowAssoc from MatchTreeMaking to ArrowAssoc[MatchTreeMaking]

### Ungrouped